---
import {
  InferGetStaticParamsType,
  InferGetStaticPropsType,
  GetStaticPaths,
} from "astro";

import BaseLayout from "../../layouts/BaseLayout.astro";
import BlogPost from "../../components/BlogPost.astro";

// The getStaticPaths function returns an array of page routes,
// and all of the pages at those routes will use the same template defined in the file.
// docs.astro.build/en/guides/typescript/#infer-getstaticpaths-types
export const getStaticPaths = (async () => {
  const allPosts = await Astro.glob("../posts/*.md");
  //   return [
  //     { params: { tag: "astro" }, props: { posts: allPosts } },
  //     { params: { tag: "successes" }, props: { posts: allPosts } },
  //     { params: { tag: "community" }, props: { posts: allPosts } },
  //     { params: { tag: "blogging" }, props: { posts: allPosts } },
  //     { params: { tag: "setbacks" }, props: { posts: allPosts } },
  //     { params: { tag: "learning in public" }, props: { posts: allPosts } },
  //   ];

  const uniqueTags = [
    ...new Set(allPosts.map((post) => post.frontmatter.tags).flat()),
  ];

  return uniqueTags.map((tag) => {
    const filteredPosts = allPosts.filter((post) =>
      post.frontmatter.tags.includes(tag)
    );

    return {
      params: { tag },
      props: { posts: filteredPosts },
    };
  });
}) satisfies GetStaticPaths;

type Params = InferGetStaticParamsType<typeof getStaticPaths>;
type Props = InferGetStaticPropsType<typeof getStaticPaths>;

const { tag } = Astro.params as Params;
const { posts } = Astro.props as Props;
// const filteredPosts = posts.filter((post) =>
//   post.frontmatter.tags.includes(tag)
// );
---

<BaseLayout pageTitle={tag}>
  <p>Posts tagged with {tag}</p>
  <!-- {
      filteredPosts.length > 0 &&
        filteredPosts.map((post) => (
          <BlogPost url={post.url} title={post.frontmatter.title} />
        ))
    } -->
  <ul>
    {
      posts.map((post) => (
        <BlogPost url={post.url} title={post.frontmatter.title} />
      ))
    }
  </ul>
</BaseLayout>
